#include "mainwindow.h"
#include "ui_mainwindow.h"
#include <QGraphicsScene>
#include <QGraphicsRectItem>
#include <QGraphicsEllipseItem>

class Rectangle;

void zmenObdelnik (Rectangle * r);

class Rectangle : public QGraphicsRectItem
{
protected:
    void (*zmena) (Rectangle *);

    virtual void mousePressEvent(QGraphicsSceneMouseEvent * event)
    {
        // setPos (x()+10, y()+10);
        zmena (this);
    }

public:
    Rectangle ()
    {
        zmena = zmenObdelnik;
    }
};

void zmenObdelnik (Rectangle * r)
{
    r->setBrush (QColor ("greenyellow"));
}

void zmensiObdelnik (Rectangle * r)
{
    r->setRect (r->x()+5, r->y()+5, r->rect().width()-10, r->rect().height()-10);
}

void zvetsiObdelnik (Rectangle * r)
{
    r->setRect (r->x()-5, r->y()-5, r->rect().width()+10, r->rect().height()+10);
}

class Zvetsi : public Rectangle
{
public:
    Zvetsi ()
    {
        zmena = zvetsiObdelnik;
    }
};

class Zmensi : public Rectangle
{
public:
    Zmensi ()
    {
        zmena = zmensiObdelnik;
    }
};

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);

    QGraphicsScene * scene = new QGraphicsScene ();
    ui->graphicsView->setScene (scene);
    scene->setSceneRect (0, 0, 1024, 800);
    // scene->addRect (0, 0, 200, 100);
    // scene->addLine (0, 0, 200, 100);
    // scene->addText ("Hello");

    QGraphicsRectItem * r = new Zmensi;
    r->setRect (50, 50, 300, 200);
    r->setPen (QColor ("blue"));
    r->setBrush (QColor ("yellow"));
    r->setFlag (QGraphicsItem::ItemIsMovable);
    scene->addItem (r);

    r = new Zvetsi;
    r->setRect (75, 75, 300, 200);
    r->setPen (QColor ("blue"));
    r->setBrush (QColor ("red"));
    r->setFlag (QGraphicsItem::ItemIsMovable);
    scene->addItem (r);

    QGraphicsEllipseItem * e = new QGraphicsEllipseItem;
    e->setRect (100, 100, 300, 200);
    e->setPen (QColor ("red"));
    e->setBrush (QColor ("cornflowerblue"));
    e->setFlag (QGraphicsItem::ItemIsMovable);
    scene->addItem (e);
}

MainWindow::~MainWindow()
{
    delete ui;
}
